Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1)
@@ -786,15 +359,26 @@
 !
 !--       Transfer initial profiles to the arrays of the 3D model
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                e(:,j,i)  = e1d
+                kh(:,j,i) = kh1d
+                km(:,j,i) = km1d
                 pt(:,j,i) = pt_init
+             ENDDO
+          ENDDO
+          DO  i = nxl-1, nxr+uxrp+1
+             DO  j = nys-1, nyn+1
                 u(:,j,i)  = u1d
+             ENDDO
+          ENDDO
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+vynp+1
                 v(:,j,i)  = v1d
              ENDDO
           ENDDO
 
-          IF ( humidity )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+          IF ( moisture  .OR.  passive_scalar )  THEN
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
                    q(:,j,i) = q_init
                 ENDDO
@@ -802,81 +386,120 @@
           ENDIF
 
-          IF ( passive_scalar )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   s(:,j,i) = s_init
-                ENDDO
-             ENDDO
-          ENDIF
-!
-!--          Store initial profiles for output purposes etc.
           IF ( .NOT. constant_diffusion )  THEN
-             hom(:,1,25,:) = SPREAD( l1d, 2, statistic_regions+1 )
-          ENDIF
-!
-!--       Set velocities back to zero
-          u = MERGE( u, 0.0_wp, BTEST( wall_flags_total_0, 1 ) )
-          v = MERGE( v, 0.0_wp, BTEST( wall_flags_total_0, 2 ) )
-!
-!--       WARNING: The extra boundary conditions set after running the 1D model impose an error on
-!--       -------- the divergence one layer below the topography; need to correct later
-!--       ATTENTION: Provisional correction for Piacsek & Williams advection scheme: keep u and v
-!--       ---------- zero one layer below the topography.
-          IF ( ibc_uv_b == 1 )  THEN
-!
-!--          Neumann condition
              DO  i = nxl-1, nxr+1
                 DO  j = nys-1, nyn+1
-                   u(nzb,j,i) = u(nzb+1,j,i)
-                   v(nzb,j,i) = v(nzb+1,j,i)
+                   e(:,j,i)  = e1d
                 ENDDO
              ENDDO
-
-          ENDIF
-!
-!--       Initialize surface variables, e.g. friction velocity, momentum fluxes, etc.
-          CALL init_surfaces
-
-          IF ( debug_output )  CALL  debug_message( 'initializing with 1D model profiles', 'end' )
-
-       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )  THEN
-
-          IF ( debug_output )  CALL  debug_message( 'initializing with constant profiles', 'start' )
-
-!
-!--       Use constructed initial profiles (velocity constant with height, temperature profile with
-!--       constant gradient)
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                pt(:,j,i) = pt_init
-                u(:,j,i)  = u_init
-                v(:,j,i)  = v_init
-             ENDDO
-          ENDDO
-!
-!--       Mask topography
-          u = MERGE( u, 0.0_wp, BTEST( wall_flags_total_0, 1 ) )
-          v = MERGE( v, 0.0_wp, BTEST( wall_flags_total_0, 2 ) )
-!
-!--       Set initial horizontal velocities at the lowest computational grid levels to zero in order
-!--       to avoid too small time steps caused by the diffusion limit in the initial phase of a run
-!--       (at k=1, dz/2 occurs in the limiting formula!).
-!--       Please note, in case land- or urban-surface model is used and a spinup is applied, masking
-!--       the lowest computational level is not possible as MOST as well as energy-balance
-!--       parametrizations will not work with zero wind velocity.
-          IF ( ibc_uv_b /= 1  .AND.  .NOT. spinup )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt
-                      u(k,j,i) = MERGE( u(k,j,i), 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 20 ) )
-                      v(k,j,i) = MERGE( v(k,j,i), 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 21 ) )
+!
+!--          Store initial profiles for output purposes etc.
+             hom(:,1,25,:) = SPREAD( l1d, 2, statistic_regions+1 )
+
+             IF ( prandtl_layer )  THEN
+                rif  = rif1d(nzb+1)
+                ts   = 0.0  ! could actually be computed more accurately in the
+                            ! 1D model. Update when opportunity arises.
+                us   = us1d
+                usws = usws1d
+                vsws = vsws1d
+             ELSE
+                ts   = 0.0  ! must be set, because used in
+                rif  = 0.0  ! flowste
+                us   = 0.0
+                usws = 0.0
+                vsws = 0.0
+             ENDIF
+
+          ELSE
+             e    = 0.0  ! must be set, because used in
+             rif  = 0.0  ! flowste
+             ts   = 0.0
+             us   = 0.0
+             usws = 0.0
+             vsws = 0.0
+          ENDIF
+
+!
+!--       In every case qs = 0.0 (see also pt)
+!--       This could actually be computed more accurately in the 1D model.
+!--       Update when opportunity arises!
+          IF ( moisture  .OR.  passive_scalar )  qs = 0.0
+
+!
+!--       inside buildings set velocities back to zero
+          IF ( topography /= 'flat' )  THEN
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   u(nzb:nzb_u_inner(j,i),j,i) = 0.0
+                   v(nzb:nzb_v_inner(j,i),j,i) = 0.0
+                ENDDO
+             ENDDO
+!
+!--          WARNING: The extra boundary conditions set after running the
+!--          -------  1D model impose an error on the divergence one layer
+!--                   below the topography; need to correct later 
+!--          ATTENTION: Provisional correction for Piacsek & Williams
+!--          ---------  advection scheme: keep u and v zero one layer below
+!--                     the topography.
+             IF ( ibc_uv_b == 0 )  THEN
+!
+!--             Satisfying the Dirichlet condition with an extra layer below
+!--             the surface where the u and v component change their sign.
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      IF ( nzb_u_inner(j,i) == 0 ) u(0,j,i) = -u(1,j,i)
+                      IF ( nzb_v_inner(j,i) == 0 ) v(0,j,i) = -v(1,j,i)
                    ENDDO
                 ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( humidity )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+
+             ELSE
+!
+!--             Neumann condition
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      IF ( nzb_u_inner(j,i) == 0 ) u(0,j,i) = u(1,j,i)
+                      IF ( nzb_v_inner(j,i) == 0 ) v(0,j,i) = v(1,j,i)
+                   ENDDO
+                ENDDO
+
+             ENDIF
+
+          ENDIF
+
+       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 ) &
+       THEN
+!
+!--       Use constructed initial profiles (velocity constant with height,
+!--       temperature profile with constant gradient)
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                pt(:,j,i) = pt_init
+             ENDDO
+          ENDDO
+          DO  i = nxl-1, nxr+uxrp+1
+             DO  j = nys-1, nyn+1
+                u(:,j,i)  = u_init
+             ENDDO
+          ENDDO
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+vynp+1
+                v(:,j,i)  = v_init
+             ENDDO
+          ENDDO
+!
+!--       Set initial horizontal velocities at the lowest grid levels to zero
+!--       in order to avoid too small time steps caused by the diffusion
+!--       limit in the initial phase of a run (at k=1, dz/2 occurs in the
+!--       limiting formula!)
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                u(nzb:nzb_u_inner(j,i)+1,j,i) = 0.0
+                v(nzb:nzb_v_inner(j,i)+1,j,i) = 0.0
+             ENDDO
+          ENDDO
+
+          IF ( moisture  .OR.  passive_scalar )  THEN
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
                    q(:,j,i) = q_init
                 ENDDO
@@ -884,79 +507,57 @@
           ENDIF
 
-          IF ( passive_scalar )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   s(:,j,i) = s_init
-                ENDDO
-             ENDDO
-          ENDIF
-
-!
-!--       Compute initial temperature field and other constants used in case of a sloping surface.
+          
+          IF ( constant_diffusion )  THEN
+             km   = km_constant
+             kh   = km / prandtl_number
+          ELSE
+             kh   = 0.01   ! there must exist an initial diffusion, because 
+             km   = 0.01   ! otherwise no TKE would be produced by the
+                           ! production terms, as long as not yet
+                           ! e = (u*/cm)**2 at k=nzb+1
+          ENDIF
+          e    = 0.0
+          rif  = 0.0
+          ts   = 0.0
+          us   = 0.0
+          usws = 0.0
+          vsws = 0.0
+          IF ( moisture  .OR.  passive_scalar ) qs = 0.0
+
+!
+!--       Compute initial temperature field and other constants used in case
+!--       of a sloping surface
           IF ( sloping_surface )  CALL init_slope
-!
-!--       Initialize surface variables, e.g. friction velocity, momentum fluxes, etc.
-          CALL init_surfaces
-
-          IF ( debug_output )  CALL debug_message( 'initializing with constant profiles', 'end' )
-
-       ELSEIF ( INDEX(initializing_actions, 'by_user') /= 0 )  THEN
-
-          IF ( debug_output )  CALL debug_message( 'initializing by user', 'start' )
-!
-!--       Pre-initialize surface variables, i.e. setting start- and end-indices at each
-!--       (j,i)-location. Please note, this does not supersede user-defined initialization of
-!--       surface quantities.
-          CALL init_surfaces
-!
-!--       Initialization will completely be done by the user
-          CALL user_init_3d_model
-
-          IF ( debug_output )  CALL debug_message( 'initializing by user', 'end' )
-
-       ENDIF
-
-       IF ( debug_output )  THEN
-          CALL debug_message( 'initializing statistics, boundary conditions, etc.', 'start' )
-       ENDIF
-
-!
-!--    Bottom boundary
-       IF ( ibc_uv_b == 0  .OR.  ibc_uv_b == 2  )  THEN
-          u(nzb,:,:) = 0.0_wp
-          v(nzb,:,:) = 0.0_wp
-       ENDIF
-
-!
-!--    Apply channel flow boundary condition
-       IF ( TRIM( bc_uv_t ) == 'dirichlet_0' )  THEN
-          u(nzt+1,:,:) = 0.0_wp
-          v(nzt+1,:,:) = 0.0_wp
+
        ENDIF
 
 !
 !--    Calculate virtual potential temperature
-       IF ( humidity )  vpt = pt * ( 1.0_wp + 0.61_wp * q )
-
-!
-!--    Store initial profiles for output purposes etc.. Please note, in case of initialization of u,
-!--    v, w, pt, and q via output data derived from larger scale models, data will not be
-!--    horizontally homogeneous. Actually, a mean profile should be calculated before.
+       IF ( moisture ) vpt = pt * ( 1.0 + 0.61 * q )
+
+!
+!--    Store initial profiles for output purposes etc.
        hom(:,1,5,:) = SPREAD( u(:,nys,nxl), 2, statistic_regions+1 )
        hom(:,1,6,:) = SPREAD( v(:,nys,nxl), 2, statistic_regions+1 )
-       IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2)  THEN
-          hom(nzb,1,5,:) = 0.0_wp
-          hom(nzb,1,6,:) = 0.0_wp
+       IF ( ibc_uv_b == 0 )  THEN
+          hom(nzb,1,5,:) = -hom(nzb+1,1,5,:)  ! due to satisfying the Dirichlet 
+          hom(nzb,1,6,:) = -hom(nzb+1,1,6,:)  ! condition with an extra layer 
+              ! below the surface where the u and v component change their sign
        ENDIF
        hom(:,1,7,:)  = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
-
-       IF ( humidity )  THEN
-!
-!--       Store initial profile of total water content, virtual potential temperature
+       hom(:,1,23,:) = SPREAD( km(:,nys,nxl), 2, statistic_regions+1 )
+       hom(:,1,24,:) = SPREAD( kh(:,nys,nxl), 2, statistic_regions+1 )
+
+
+       IF ( moisture )  THEN
+!
+!--       Store initial profile of total water content, virtual potential
+!--       temperature 
           hom(:,1,26,:) = SPREAD(   q(:,nys,nxl), 2, statistic_regions+1 )
           hom(:,1,29,:) = SPREAD( vpt(:,nys,nxl), 2, statistic_regions+1 )
-!
-!--       Store initial profile of mixing ratio and potential temperature
-          IF ( bulk_cloud_model  .OR.  cloud_droplets ) THEN
+          IF ( cloud_physics  .OR.  cloud_droplets ) THEN
+!
+!--          Store initial profile of specific humidity and potential
+!--          temperature
              hom(:,1,27,:) = SPREAD(  q(:,nys,nxl), 2, statistic_regions+1 )
              hom(:,1,28,:) = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
@@ -964,45 +565,131 @@
        ENDIF
 
-!
-!--    Store initial scalar profile
        IF ( passive_scalar )  THEN
-          hom(:,1,121,:) = SPREAD(  s(:,nys,nxl), 2, statistic_regions+1 )
-       ENDIF
-
-!
-!--    Initialize the random number generators (from numerical recipes)
-       CALL random_function_ini
-
-       IF ( random_generator == 'random-parallel' )  THEN
-          CALL init_parallel_random_generator( nx, nys, nyn, nxl, nxr )
-       ENDIF
-!
-!--    Set the reference state to be used in the buoyancy terms (for ocean runs the reference state
-!--    will be set (overwritten) in init_ocean).
-       IF ( use_single_reference_value )  THEN
-          IF ( .NOT. humidity )  THEN
-             ref_state(:) = pt_reference
-          ELSE
-             ref_state(:) = vpt_reference
-          ENDIF
-       ELSE
-          IF ( .NOT. humidity )  THEN
-             ref_state(:) = pt_init(:)
-          ELSE
-             ref_state(:) = vpt(:,nys,nxl)
-          ENDIF
-       ENDIF
-
-!
-!--    For the moment, vertical velocity is zero
-       w = 0.0_wp
+!
+!--       Store initial scalar profile
+          hom(:,1,26,:) = SPREAD(  q(:,nys,nxl), 2, statistic_regions+1 )
+       ENDIF
+
+!
+!--    Initialize surface fluxes
+       IF ( use_surface_fluxes )  THEN
+
+          IF ( constant_heatflux )  THEN
+!
+!--          Heat flux is prescribed
+             IF ( random_heatflux )  THEN
+                CALL disturb_heatflux
+             ELSE
+                shf = surface_heatflux
+!
+!--             Over topography surface_heatflux is replaced by wall_heatflux(0)
+                IF ( TRIM( topography ) /= 'flat' )  THEN
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         IF ( nzb_s_inner(j,i) /= 0 )  THEN
+                            shf(j,i) = wall_heatflux(0)
+                         ENDIF
+                      ENDDO
+                   ENDDO
+                ENDIF
+             ENDIF
+             IF ( ASSOCIATED( shf_m ) )  shf_m = shf
+          ENDIF
+
+!
+!--       Determine the near-surface water flux
+          IF ( moisture  .OR.  passive_scalar )  THEN
+             IF ( constant_waterflux )  THEN
+                qsws   = surface_waterflux
+                IF ( ASSOCIATED( qsws_m ) )  qsws_m = qsws
+             ENDIF
+          ENDIF
+
+       ENDIF
+
+!
+!--    Initialize Prandtl layer quantities
+       IF ( prandtl_layer )  THEN
+
+          z0 = roughness_length
+
+          IF ( .NOT. constant_heatflux )  THEN 
+!
+!--          Surface temperature is prescribed. Here the heat flux cannot be
+!--          simply estimated, because therefore rif, u* and theta* would have
+!--          to be computed by iteration. This is why the heat flux is assumed
+!--          to be zero before the first time step. It approaches its correct
+!--          value in the course of the first few time steps.
+             shf   = 0.0
+             IF ( ASSOCIATED( shf_m ) )  shf_m = 0.0
+          ENDIF
+
+          IF ( moisture  .OR.  passive_scalar )  THEN
+             IF ( .NOT. constant_waterflux )  THEN
+                qsws   = 0.0
+                IF ( ASSOCIATED( qsws_m ) )   qsws_m = 0.0
+             ENDIF
+          ENDIF
+
+       ENDIF
+
+!
+!--    Calculate the initial volume flow at the right and north boundary
+       IF ( conserve_volume_flow )  THEN
+
+          volume_flow_initial_l = 0.0
+          volume_flow_area_l    = 0.0
+  
+          IF ( nxr == nx )  THEN
+             DO  j = nys, nyn
+                DO  k = nzb_2d(j,nx) + 1, nzt
+                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
+                                              u(k,j,nx) * dzu(k)
+                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzu(k)
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( nyn == ny )  THEN
+             DO  i = nxl, nxr
+                DO  k = nzb_2d(ny,i) + 1, nzt  
+                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
+                                              v(k,ny,i) * dzu(k)
+                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzu(k)
+                ENDDO
+             ENDDO
+          ENDIF
+
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( volume_flow_initial_l(1), volume_flow_initial(1),&
+                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
+          CALL MPI_ALLREDUCE( volume_flow_area_l(1), volume_flow_area(1),      &
+                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+          volume_flow_initial = volume_flow_initial_l
+          volume_flow_area    = volume_flow_area_l
+#endif  
+       ENDIF
+
+!
+!--    For the moment, perturbation pressure and vertical velocity are zero
+       p = 0.0; w = 0.0
 
 !
 !--    Initialize array sums (must be defined in first call of pres)
-       sums = 0.0_wp
-
-!
-!--    In case of iterative solvers, p must get an initial value
-       IF ( psolver(1:9) == 'multigrid'  .OR.  psolver == 'sor' )  p = 0.0_wp
+       sums = 0.0
+
+!
+!--    Treating cloud physics, liquid water content is zero at beginning of
+!--    the simulation
+       IF ( cloud_physics )  ql = 0.0
+
+!
+!--    Initialize spectra
+       IF ( dt_dosp /= 9999999.9 )  THEN
+          spectrum_x = 0.0
+          spectrum_y = 0.0
+       ENDIF
+
 !
 !--    Impose vortex with vertical axis on the initial velocity profile
@@ -1012,7 +699,6 @@
 
 !
-!--    Impose temperature anomaly (advection test only) or warm air bubble close to surface.
-       IF ( INDEX( initializing_actions, 'initialize_ptanom' ) /= 0  .OR.                          &
-            INDEX( initializing_actions, 'initialize_bubble' ) /= 0  )  THEN
+!--    Impose temperature anomaly (advection test only)
+       IF ( INDEX( initializing_actions, 'initialize_ptanom' ) /= 0 )  THEN
           CALL init_pt_anomaly
        ENDIF
@@ -1020,5 +706,5 @@
 !
 !--    If required, change the surface temperature at the start of the 3D run
-       IF ( pt_surface_initial_change /= 0.0_wp )  THEN
+       IF ( pt_surface_initial_change /= 0.0 )  THEN
           pt(nzb,:,:) = pt(nzb,:,:) + pt_surface_initial_change
        ENDIF
